config/routes.rb
Rails.application.routes.draw do
    # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
    # resources :users do
    #     get :sign_up, on: :collection
    #     # get :sign_in, on: :collection
    #     post :sign_in_user
    # end

    get '/404' => "errors#not_found"
    get '/422' => "errors#unacceptable"
    get '/500' => "errors#internal_error"

    get '/auth/:provider/callback', to: 'oauth#callback', as: 'oauth_callback'
    get '/auth/failure', to: 'oauth#failure', as: 'oauth_failure'


    devise_scope :user do
        authenticated :user do
            get '/' => 'home#index', as: :authenticated_root
        end

        unauthenticated do
            root 'sessions#new', as: :unauthenticated_root
        end
    end

    devise_for :users, controllers: { registrations: 'registrations', sessions: "sessions", passwords: "passwords" }
    devise_scope :user do
        get "user/password/successful_reset_password" , :to => "devise/passwords#successful_reset_password" , :as => :successful_reset_password
        post "verify_school_user", :to => "registrations#verify_school_user"
    end

    resources :users, only: [ :edit, :update ] do
        post :reset_password, on: :collection
        put :change_password, on: :collection
        post :upload_resume, on: :collection
        get :download_resume, on: :collection
    end

    resources :companies do
        get :get_cities, on: :collection
        post :search, on: :collection
        get :fetch_master_data, on: :collection
        post :add_company_as_favorite, on: :collection
        get :sponsored_petitions, on: :collection
        get :search_industry, on: :collection
        get :search_company, on: :collection
        get :company_select2, on: :collection
        get :industry_select2, on: :collection
        get :university_select2, on: :collection
        get :birth_country_select2, on: :collection
        get :job_title_select2, on: :collection
        get :state_select2, on: :collection
        get :city_select2, on: :collection
        post :fetch_map_data, on: :collection
    end

    resources :videos do
        get :get_video_list, on: :collection
        get :search, on: :collection
        get :order_list, on: :collection
    end

    resources :jobs, only: :index do
        post :search, on: :collection
        get :get_open_jobs, on: :collection
        post :favorite_job, on: :collection
    end

    resources :country_insights, only: [:index, :show] do
        get :search, on: :collection
    end

    resources :notifications, only: [ :index ] do
        get :read, on: :member
    end
    resources :gameplan, only: [ :index ] do
        get :take_test, on: :collection
        post :user_answers, on: :collection
    end
    resources :checklists, only: [ :index, :create ] do
        post 'delete_checklist', on: :collection, as: 'delete_checklist'
        post 'edit_checklist', on: :collection, as: 'edit_checklist'
        post 'mark_checklist', on: :collection, as: 'mark_checklist'
    end
    resources :network_trackers do
        get :search, on: :collection
    end
    resources :favorite_companies, only: [ :index, :create ]
    resources :feedbacks, only: [ :new, :create ]
    resources :contact_us, only: [ :new, :create ]

    get :list_post_comments, to: 'home#list_post_comments'
    post :add_comment, to: 'home#add_comment'
    post :like_post, to: 'home#like_post'
    post :add_post, to: 'home#add_post'
    post :favorite_post, to: 'home#favorite_post'
    get :get_link_info, to: 'home#get_link_info'
    post :delete_comment, to: 'home#delete_comment'
    post :bookmarked_articles, to: 'home#bookmarked_articles'
    get :search, to: 'home#search'
    get :delete_post, to: 'home#delete_post'

end

app/views/companies_old/_company_list.html.erb
<% if @companies_petition.present? %>
    <div class="col-sm-12">
        <h1 class="title">Companies<br/>
            <!-- <small class="blue-text">Click on a company for more details</small> -->
        </h1>
    </div>
    <div class="clearfix"></div>

    <div class="tabbar">
        <ul class="nav nav-tabs" role="tablist">
            <li role="presentation" class="active"><a href="#tab1" aria-controls="tab1" role="tab" data-toggle="tab">Petitions</a></li>
            <% unless params[:type].eql?('alumni') %>
            <li role="presentation"><a href="#tab2" aria-controls="tab2" role="tab" data-toggle="tab">Average Salary</a></li>
            <% end %>
            <li role="presentation"><a href="#tab3" aria-controls="tab3" role="tab" data-toggle="tab" id="visa_map">Maps</a></li>
        </ul>
        <!-- Tab panes -->
        <div class="tab-content">
            <div role="tabpanel" class="tab-pane active" id="tab1">
                <div class="charts">
                    <% max_petition = companies_petition.first.no_of_petition.to_i + 10 %>
                    <%# chart_colors = [ 'cyan', 'red', 'blue', 'green', 'amber', 'purple', 'grey', 'yellow' ] %>
                    <% chart_colors = [ 'cyan', 'lavender', 'aqua', 'mustard', 'pink', 'lemon', 'carrot', 'sea', 'purple', 'green' ] %>
                    <% count = 0 %>
                    <% companies_petition.each_with_index do |company, index| %>
                        <% is_fav = FavoriteCompany.find_by(company_id: company.company_id, user_id: current_user.id).present? %>
                        <div class="chart-cell">
                            <a href="<%= company_path(id: company.company_id, tab_type: params[:type]) %>">
                                <span>
                                    <%= "#{company.employer_name.capitalize}" %> <b><%= "(#{number_with_delimiter(company.no_of_petition)})" %> </b>
                                    <div class="star_icon pull-right">
                                        <a data-toggle="tooltip" data-placement="right" title="Add to Favorite" href="javascript:void(0);" class="fav-icon  <%= is_fav ? 'active' : '' %>" data-company-id="<%= company.company_id %>" data-company-name="<%= company.employer_name %>" id="fav_company"></a>
                                    </div>
                                </span>
                                <!-- <div class="charts__chart chart--p90 chart--cyan" data-percent="<%#= company.no_of_petition  %>"></div> -->
                                <%# logger.info "====pet===#{company.no_of_petition}" %>
                                <% percent = (company.no_of_petition.to_f / max_petition.to_f) * 100 %>
                                <div class="charts__chart chart--p<%= percent.to_i %> chart--<%= chart_colors[count] %>" data-percent="<%= company.no_of_petition  %>"></div>
                            </a>
                        </div>
                        <% if count >= chart_colors.count - 1 %>
                            <% count = 0 %>
                        <%  else %>
                            <% count += 1 %>
                        <% end %>
                    <% end if companies_petition.present? %>
                </div>
            </div>
            <% if params[:type].present? && !params[:type].eql?('alumni') %>
            <div role="tabpanel" class="tab-pane" id="tab2">

                <div class="charts">
                    <% max_wage = companies_wage.first.wage_rate_of_pay_from.to_i + 10 %>
                    <%# chart_colors = [ 'cyan', 'red', 'blue', 'green', 'amber', 'purple', 'grey', 'yellow' ] %>
                    <% chart_colors = [ 'cyan', 'lavender', 'aqua', 'mustard', 'pink', 'lemon', 'carrot', 'sea', 'purple', 'green' ] %>
                    <% count = 0 %>
                    <% companies_wage.each_with_index do |company, index| %>
                        <% is_fav = FavoriteCompany.find_by(company_id: company.company_id, user_id: current_user.id).present? %>
                        <div class="chart-cell">
                            <a href="<%= company_path(id: company.company_id, tab_type: params[:type]) %>">
                                <span><%= "#{company.employer_name.capitalize}" %> <b><%= "($#{number_to_human(company.wage_rate_of_pay_from, format: '%n%u', precision: 2, units: { million: 'M', thousand: 'K' })})" %> </b></span>
                                <!-- <div class="charts__chart chart--p90 chart--cyan" data-percent="<%#= company.no_of_petition  %>"></div> -->
                                <%# logger.info "====pet===#{company.no_of_petition}" %>
                                <div class="star_icon pull-right">
                                    <a data-toggle="tooltip" data-placement="right" title="Add to Favorite" href="javascript:void(0);" class="fav-icon  <%= is_fav ? 'active' : '' %>" data-company-id="<%= company.company_id %>" data-company-name="<%= company.employer_name %>" id="fav_company"></a>
                                </div>
                                <% percent = (company.wage_rate_of_pay_from.to_f / max_wage.to_f) * 100 %>
                                <div class="charts__chart chart--p<%= percent.to_i %> chart--<%= chart_colors[count] %>" data-percent="<%= company.wage_rate_of_pay_from  %>"></div>
                            </a>
                        </div>
                        <% if count >= chart_colors.count - 1 %>
                            <% count = 0 %>
                        <%  else %>
                            <% count += 1 %>
                        <% end %>
                    <% end %>
                </div>
            </div>
            <% end %>
            <div role="tabpanel" class="tab-pane" id="tab3">
                <!-- <div style="position: absolute; width: 100%; height: 100%"> -->
                    <div id="map1"></div>
                <!-- </div> -->
            </div>
        </div>
    </div>
<% else %>
    <div class="col-sm-12 no_companies">
        <h1 class="title"> No companies found for this search </h1>
    </div>
<% end %>
<script src="https://developers.google.com/maps/documentation/javascript/examples/markerclusterer/markerclusterer.js"></script>
<script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyAQoyHt6t48brE7eZT4yGhSC4eGs0Hlclg"></script>
<!-- <script src="https://developers.google.com/maps/documentation/javascript/examples/markerclusterer/markerclusterer.js"></script> -->
<script>
function initMap() {
          // var loct = <%#= raw(marker.to_json) %>
          // console.log(loct[0])
          // var map = new google.maps.Map(document.getElementById('map1'), {
          //   zoom: 5,
          //   // center: loct[0]
          // });
          // geocoder = new google.maps.Geocoder();
          // geocoder.geocode( { 'address': "Australia" }, function(results, status) {
          //     map.setCenter(results[0].geometry.location);
          //     var marker = new google.maps.Marker({
          //         map: map,
          //         position: results[0].geometry.location,
          //         // label: labels[i % labels.length]
          //     // alert(1)
          //     });
          // })

          var loct = <%= raw(marker.to_json) %>
          var map = new google.maps.Map(document.getElementById('map1'), {
              zoom: 3,
              center: loct[0]
          });


          var markers = loct.map(function(location, i) {
              //console.log(location);
              //console.log(i);
              return new google.maps.Marker({
                  position: location,
                  count: location.petition,
                  // label: labels[i % labels.length]
              });
              // alert(1)
          });

          var clusterStyles = [
              {
                textColor: 'white',
                url: '/assets/marker/small.png',
                height: 24,
                width: 24
              },
              {
                textColor: 'white',
                url: '/assets/marker/medium.png',
                height: 24,
                width: 24
              },
              {
                textColor: 'white',
                url: '/assets/marker/large.png',
                height: 32,
                width: 32
              },
             // {
             //    textColor: 'white',
             //    url: '/assets/marker/medium1.png',
             //    height: 50,
             //    width: 50
             //  },
             // {
             //    textColor: 'white',
             //    url: '/assets/marker/medium.png',
             //    height: 50,
             //    width: 50
             //  }
            ];

            var mcOptions = {
                gridSize: 50,
                styles: clusterStyles,
                // maxZoom: 15
            };

          // var markerCluster = new MarkerClusterer(map, markers, {imagePath: 'https://developers.google.com/maps/documentation/javascript/examples/markerclusterer/m'});
          var markerCluster = new MarkerClusterer(map, markers, mcOptions);

          markerCluster.setCalculator(function(markers, numStyles){
              //create an index for icon styles
                  // console.log(markers);
                  var sum = 0
                  $.each(markers, function(i, value){
                      // console.log("=============");
                      // console.log(value);
                      sum = sum + value.count
                  })
                  // markers.each(function(value, i){
                  //     console.log("===================================");
                  //     console.log(value);
                  //     console.log(i);
                  //     console.log("===================================");
                  // })
                  // count = sum + markers.length,
                  count = sum,
              //Set total to loop through (starts at total number)
                  total = count;
                  var index = 0
                  while (total !== 0) {
                      //Create a new total by dividing by a set number
                      total = parseInt(total / 5, 10);
                      //Increase the index and move up to the next style
                      index++;
                  }

                  /**
                   * Make sure we always return a valid index. E.g. If we only have
                   * 5 styles, but the index is 8, this will make sure we return
                   * 5. Returning an index of 8 wouldn't have a marker style.
                   */
                  index = Math.min(index, numStyles);


              return {
                  // text: count + " ("+ index + ")",
                  // index: index
                  text: prettifyNumber(count),
                  index: index
              };
          });

          // geocoder.geocode( { 'address': "<%#= @country.name %>" }, function(results, status) {
          //     map.setCenter(results[0].geometry.location);
          // }

          // // Add a marker clusterer to manage the markers.
          // var markerCluster = new MarkerClusterer(map, markers, {imagePath: 'https://developers.google.com/maps/documentation/javascript/examples/markerclusterer/m'});
}

function prettifyNumber(value) {
    var thousand = 1000;
    var million = 1000000;
    var billion = 1000000000;
    var trillion = 1000000000000;
    if (value < thousand) {
        return String(value);
    }

    if (value >= thousand && value <= 1000000) {
         return  Math.round(value/thousand) + 'k';
    }

    if (value >= million && value <= billion) {
        return Math.round(value/million) + 'M';
        }

         if (value >= billion && value <= trillion) {
             return Math.round(value/billion) + 'B';
         }

         else {
             return Math.round(value/trillion) + 'T';
         }
     }

$('#visa_map').on('click', function(){
    $('.loader').show();
    initMap();
    // height: 100%; width: 100%; position: absolute; top: 0px; left: 0px; background-color: rgb(229, 227, 223);
    setTimeout(function(){
        $('#map1 div').first().removeAttr('style')
        $('#map1 div').first().css({ 'height': '500px', 'width' : '500px', 'top': '0px', 'left': '0px', 'background-color': 'rgb(229, 227, 223)', 'position': 'relative !important' });
    }, 1000)
    $('.loader').hide()
})
</script>

app/views/companies_old/_list_visa_companies.html.erb
<% @companies.each do |i| %>
    <label class="ccheckbox"><%= i.company_name %>
        <input type="checkbox" name='search[company_ids][]' value="<%= i.id %>">
        <span class="checkmark"></span>
    </label>
<% end %>

app/views/companies_old/_list_visa_industries.html.erb
<% @industries.each do |i| %>
    <label class="ccheckbox"><%= i.industry_name %>
        <input type="checkbox" name='search[industry_ids][]' value="<%= i.id %>">
        <span class="checkmark"></span>
    </label>
<% end %>

app/views/companies_old/add_company_as_favorite.js.erb
<%= logger.info "==@fav_company=#{@favorite_companies.inspect}" %>
<%#= custom_bootstrap_flash %>
$('.fav_companies').empty().html("<%= j render partial: '/layouts/sidebar_right', locals: { '@companies': @companies, '@favorite_companies': @favorite_companies } %>")

app/views/companies_old/fetch_master_data.js.erb
// Update state dropdown
var state = $('#search_state_ids')
state.empty()
$.each("<%= @response[:states] %>", function(key, value){
    var option = new Option(value[1], value[0]);
    state.append(option).trigger('change');

    // manually trigger the `select2:select` event
    state.trigger({
        type: 'select2:select',
        params: {
          data: value
        }
    });
})
//
// // =============================================== //
// // Update Job title dropdown
// var title = $('#search_job_title_ids')
// title.empty()
// $.each(response.job_titles, function(key, value){
//     var option = new Option(value[1], value[0]);
//     title.append(option).trigger('change');
//
//     // manually trigger the `select2:select` event
//     title.trigger({
//         type: 'select2:select',
//         params: {
//           data: value
//         }
//     });
// })
//
// // =============================================== //
// // Update Industry
// var industry = $('#search_industry_ids')
// industry.empty()
// $.each(response.industries, function(key, value){
//     var option = new Option(value[1], value[0]);
//     industry.append(option).trigger('change');
//
//     // manually trigger the `select2:select` event
//     title.trigger({
//         type: 'select2:select',
//         params: {
//           data: value
//         }
//     });
// })

app/views/companies_old/get_cities.js.erb
$("#search_city_ids").html('<%=j options_from_collection_for_select(@cities, "id", "city_name") %>');

app/views/companies_old/search.js.erb
<%# logger.info "com===#{@companies.inspect}" %>
// console.log($(".article_companies"))
<% if @companies_petition.present? %>
    $(".companies").empty().append("<%= escape_javascript render(:partial => 'company_list', :locals => { :companies_petition => @companies_petition, :companies_wage => @companies_wage, :marker => @markers }) %>")
<% else %>
    $(".companies").empty().append("<%= escape_javascript render(:partial => 'company_list', :locals => { :companies_petition => @companies_petition, :companies_wage => @companies_wage, :marker => @markers }) %>")
<% end %>
$('.chart-cell .star_icon').hide()
$('.chart-cell').on('mouseover', function(){
    // alert(1)
    // console.log($(this).children('div.star_icon'));
    $(this).children('div.star_icon').show()
    // $('.chart-cell .star_icon').show()
})
$('.chart-cell').on('mouseout', function(){
    // alert(1)
    $('.chart-cell .star_icon').hide()
})
$('.chart-cell .star_icon').on('click', function(e){
    console.log($(this).children('a.fav-icon'));
    var company_id = $(this).children('a.fav-icon').data('company-id')
    // var tab_type = $(this).data('tab-type')
    var company_name = $(this).children('a.fav-icon').data('company-name')
    var like = 'unlike'
    if($(this).children('a.fav-icon').hasClass('active') == true){
        $(this).children('a.fav-icon').removeClass('active')
        like = 'unlike'
    }else {
        $(this).children('a.fav-icon').addClass('active')
        like = 'like'
    }
    e.preventDefault()
    e.stopImmediatePropagation()
    console.log(company_id);
    console.log(company_name);
    $.ajax({
        url: '/interstride/companies/add_company_as_favorite',
        method: 'post',
        data: { company_id: company_id, company_name: company_name, like: like },
        dataType: 'script',
        // success: function(response){
        //     $('.loader').hide()
        //     console.log(response);
        //     toastr.success(response['message'])
        //     window.location.reload(true)
        // },
        // failure: function(response){
        //     $('.loader').hide()
        // }

    })
})

app/views/companies_old/search_company.js.erb
$('.list_company').empty().append("<%= j render partial: '/companies/list_visa_companies', locals: { '@companies': @companies } %>")

app/views/companies_old/search_industry.js.erb
$('.list_industry').empty().append("<%= j render partial: '/companies/list_visa_industries', locals: { '@industries': @industries } %>")

app/views/companies_old/show.html.erb
<!--section-->
<section>
  <div class="container">
    <div class="row">
      <!--left-section-->
      <div class="col-md-3">
        <div class="cominfo">

            <div class="clogo">
                <figure>
                    <!-- <img src="images/ey_logo.png" alt="" class="img-circle" /> -->
                    <% logger.info "===comp===#{@company_details.inspect}" %>
                    <%= image_tag @company_details[:company_logo].present? ? @company_details[:company_logo] : 'company_logo.png', class: 'img-circle' %>
                </figure>
                <h1><%= @company_details['employer_name'] %></h1>

            </div>

            <div class="form-group">
                <label>Industry</label>
                <h2><%= @company_details['industry'] %></h2>
            </div>
            <div class="form-group">
                <label>Employees</label>
                <h2><%= @company_details['employees'].present? ? @company_details['employees'] : '-' %></h2>
            </div>

          </div>
      </div>
      <!--/left-section-->

      <!--middle-section-->
      <div class="col-md-9 col-xs-12">
        <div class="article cdetails">
          <div class="header margin-bottom-15">
              <h1><a href="<%= companies_path %>" class="back-icon"></a><%= @company_details['employer_name'] %></h1>
              <div class="form-group star_icon">
                  <a data-toggle="tooltip" data-placement="right" title="Add to Favorite" href="#" class="fav-icon <%= @company_details[:is_favorite] == true ? 'active' : '' %>" data-tab-type="<%= params[:tab_type]%>" data-company-id="<%= @company_details['company_id'] %>" data-company-name="<%= @company_details['employer_name'] %>" id="fav_company"></a>
              </div>
          </div>
          <div class="article-content">
              <%= @company_details['company_description'] %>
              <div class="divider"></div>

              <h3 class=""> Learn more about this company </h3>
              <div class="cs_btn">

                  <%# if @company_details[:linkedin_link].present? %>
                  <a href="<%= @company_details[:linkedin_link].present? ? @company_details[:linkedin_link] : 'javascript:void(0)' %>" target="_blank"><img src="/interstride/assets/link_icon.png" alt="" /><p>LinkedIn</p></a>
                  <%# end %>
                  <a href="<%= @company_details[:crunchbase_link].present? ? @company_details[:crunchbase_link] : 'javascript:void(0)' %>" target="_blank"><img src="/interstride/assets/cb_icon.png" alt="" /><p>Crunchbase</p></a>

                  <a href="<%= @company_details[:wikipedia_link].present? ? @company_details[:wikipedia_link] : 'javascript:void(0)' %>" target="_blank"><img src="/interstride/assets/w_icon.png" alt="" /><p>Wikipedia</p></a>
                  <%# if @company_details['glassdoor_link'].present? %>
                  <!-- <a href="<%#= @company_details['website'].present? ? @company_details['website'] : 'javascript:void(0)' %>" target="_blank"><img src="/interstride/assets/g_icon.png" alt="" /></a> -->
                  <a href="https://news.google.com/search?q=<%= @company_details['employer_name'] %>" target="_blank"><img src="/interstride/assets/g_icon.png" alt="" /><p>News</p></a>
                  <a href="<%= @company_details['glassdoor_link'].present? ? @company_details['glassdoor_link'] : 'javascript:void(0)' %>" target="_blank"><img src="/interstride/assets/con_icon.png" alt="" /><p>Glassdoor</p></a>
                  <%# end %>
                  <%# if @company_details[:crunchbase_link].present? %>
                  <%# end %>
                  <%# if @company_details[:wikipedia_link].present? %>
                  <%# end %>
                  <%# if @company_details['website'].present? %>
                  <%# end %>
              </div>


              <div class="divider"></div>

              <div class="com_btn">
                  <div class="row">
                  <div class="col-md-4"><a class="btn btn-theme3 rounded margin-bottom-15" href="<%= get_open_jobs_jobs_path(company_name: @company_details['employer_name']) %>" target="_blank">Search Open Jobs</a></div>
                  <div class="col-md-4"><a class="btn btn-theme rounded margin-bottom-15" href="<%= network_trackers_path %>" target="_blank">Open My Meetings</a></div>
                  <div class="col-md-4"><a class="btn btn-theme2 rounded margin-bottom-15" href="<%= sponsored_petitions_companies_path(company_id: @company_details['company_id'] ,tab_type: params[:tab_type]) %>" target="_blank">Past Sponsored Positions</a></div>
                  </div>
              </div>

          </div>

        </div>
      </div>

      <!--/middle-section-->

      <!--right-section-->

      <!--/right-section-->
    </div>
  </div>
</section>
<!--/section-->